package com.jh.boot.template;

import java.util.List;

import javax.persistence.TypedQuery;

import org.springframework.stereotype.Repository;
import org.springframework.util.StringUtils;

import com.jh.boot.jpa.AbstractHibernateRepository;

@Repository
public class HibernateTemplateRepository extends AbstractHibernateRepository {

	
	public Template loadTemplate(String code, String locale) {
		if (code == null) {
			return null;
		}
		String hql = "select t from Template t where lower(code) = :code";
		if (StringUtils.hasText(locale)) {
			hql += " and lower(locale) = :locale";
		} else {
			hql += " and locale is null";
		}
		TypedQuery<Template> q = entityManager.createQuery(hql, Template.class);
		q.setParameter("code", code.toLowerCase());
		if (StringUtils.hasText(locale)) {
			q.setParameter("locale", locale.toLowerCase());
		}
		
		List<Template> list = q.getResultList();
		return list == null || list.isEmpty() ? null : list.get(0);
	}
	
	
}
